Procedure.s CharToOem(a$)
  CharToOem_(a$,a$)
  ProcedureReturn a$
EndProcedure
Procedure.l ParseDosDateTime(Date.w,Time.w)
  day = date & 31
  month = (date & 480) >> 5
  year = 1980 + ((date & 65024) >> 9)
  
  sec = 2 * (time & 31);
  min = (time & 2016) >> 5;
  hour = (time & 63488) >> 11;
  
  ProcedureReturn Date(year,month,day,hour,min,sec)
EndProcedure

dll7zip=OpenLibrary(#PB_Any, "7-zip32.dll")
If dll7zip
  #FNAME_MAX32 = 512  
  Structure INDIVIDUALINFO
    dwOriginalSize.l
    dwCompressedSize.l
    dwCRC.l
    uFlag.l
    uOSType.l
    wRatio.w
    wDate.w
    wTime.w
    szFileName.c[#FNAME_MAX32+1]
    dummy1.c[3]
    szAttribute.c[8]
    szMode.c[8]
  EndStructure
  
  
  Prototype.l ProtoSevenZip(hWnd.l, szCmdLine.l, stOutput.l, dwSize.l = 0)
  Global SevenZip.ProtoSevenzip = GetFunction(dll7zip, "SevenZip")
  
  Prototype.l ProtoSevenZipCheckArchive(szFileName.p-ascii, iMode.l = 0)
  Global SevenZipCheckArchive.ProtoSevenZipCheckArchive = GetFunction(dll7zip, "SevenZipCheckArchive")
  
  Prototype.l ProtoSevenZipOpenArchive(hWnd.l, szFileName.p-ascii, dwMode.l = 0)
  Global SevenZipOpenArchive.ProtoSevenZipOpenArchive = GetFunction(dll7zip,"SevenZipOpenArchive")
  
  Prototype.l ProtoSevenZipCloseArchive(HARC.l) 
  Global SevenZipCloseArchive.ProtoSevenZipCloseArchive = GetFunction(dll7zip,"SevenZipCloseArchive")
  
  Prototype.l ProtoSevenZipFindFirst(HARC.l, szWildName.p-ascii, *lpSubInfo.INDIVIDUALINFO) 
  Global SevenZipFindFirst.ProtoSevenZipFindFirst = GetFunction(dll7zip,"SevenZipFindFirst")
  
  Prototype.l ProtoSevenZipFindNext(HARC.l, *lpSubInfo.INDIVIDUALINFO)
  Global SevenZipFindNext.ProtoSevenZipFindNext = GetFunction(dll7zip,"SevenZipFindNext")
  
  ;Prototype.l ProtoSevenZipGetBackGroundMode()
  ;Global SevenZipGetBackGroundMode.ProtoSevenZipGetBackGroundMode = GetFunction(dll7zip, "SevenZipGetBackGroundMode")
  
  ;Prototype.l ProtoSevenZipSetBackGroundMode(BackGroundMode.l)
  ;Global SevenZipSetBackGroundMode.ProtoSevenZipSetBackGroundMode = GetFunction(dll7zip, "SevenZipSetBackGroundMode")
  
  
  
  
  
Else
  Debug "7z fehlt"
  End
EndIf

;Wir bentigen unbedingt ein Win7z-Window
win7z=OpenWindow(#PB_Any,0,0,10,10,"7z",#PB_Window_Invisible)
While WindowEvent():Wend
Global win7zid=WindowID(win7z)

presort.s=".\Versions\sort.txt"
versionsdir.s=".\Versions\"
tempfile.s=".\versions\filelist.txt"
patchdir.s=".\versions\patch\"

Structure sorthelp
  file.s
  sort.s
EndStructure


NewList files.sorthelp()
NewMap presort.s()


in=OpenFile(#PB_Any,presort)
countdown=9999
If in
  While Not Eof(in)
    a$=ReadString(in)
    If a$<>""
      presort(Left(a$,Len(a$)-4))="__"+Str(countdown)
      countdown-1
    EndIf
  Wend
  CloseFile(in)    
Else
  Debug "presort dont exist"
  End
EndIf

dir=ExamineDirectory(#PB_Any,versionsdir,"*.jar")
If dir
  While NextDirectoryEntry(dir)
    a$=DirectoryEntryName(dir)
    b$=Left(a$,Len(a$)-4)
    AddElement(files())
    If presort(b$)=""
      files()\sort=b$
    Else
      files()\sort=presort(b$)
    EndIf
    files()\file=a$
  Wend
  FinishDirectory(dir)
EndIf

SortStructuredList(files(),#PB_Sort_Descending,OffsetOf(sorthelp\sort),#PB_Sort_String)
 
ForEach files()
  Debug files()\file +"   "+files()\sort
Next
;End

Structure jarlist
  file.s
  crc.l
  size.l
  date.l
EndStructure

NewMap fromjar.jarlist()
NewList tojar.jarlist()

ResetList(files())
NextElement(files())


tofile.s=versionsdir+files()\file
toname.s=Left(files()\file,Len(files()\file)-4)
While NextElement(files())
  
  fromfile.s=tofile
  fromname.s=toname
  tofile.s=versionsdir+files()\file
  toname=Left(files()\file,Len(files()\file)-4)
  patchfile.s=patchdir+fromname+"#"+toname+".patch"
  
  If FileSize(patchfile)<0 ;-toname="minecraft - Alpha 1.2.0";--
    
    cmd$="x "+Chr(34)+CharToOem(tofile)+Chr(34)+" -aoa -o"+Chr(34)+CharToOem(patchdir+"tofiles\")+Chr(34)
    buf$=Space(10000)
    ret=SevenZip(win7zid, @cmd$, @buf$,9999)
    If ret
      Debug "1unpackfail "+tofile
      Debug buf$
      Repeat
        Delay(100)
      ForEver
      End
    EndIf
    
    cmd$="x "+Chr(34)+CharToOem(fromfile)+Chr(34)+" -aoa -o"+Chr(34)+CharToOem(patchdir+"fromfiles\")+Chr(34)
    ret=SevenZip(win7zid, @cmd$, 0,0)
    If ret
      Debug "unpackfail "+tofile
      End
    EndIf
    
    
    
    Debug "Create Patch "+fromfile+" to "+tofile
    
    
    ClearMap(fromjar())
    x=SevenZipOpenArchive(win7zid,fromfile)
    If x
      d=SevenZipFindFirst(x,"*",info.individualinfo)
      While d=0
        a$=PeekS(@info\szFileName)
        ;If a$<>"null"
        If a$="null"
          Debug "FROMNULL"
        EndIf
        If Right(a$,1)<>"\" And Right(a$,1)<>"/"
          fromjar(a$)\crc=info\dwCRC
          fromjar(a$)\size=info\dwOriginalSize
          fromjar(a$)\date=ParseDosDateTime(info\wDate,info\wtime)
        EndIf
        ;EndIf
        d=SevenZipFindNext(x,info)
      Wend
      ret=SevenZipCloseArchive(x)
    EndIf
    
    ClearList(tojar())
    x=SevenZipOpenArchive(win7zid,tofile)
    If x
      d=SevenZipFindFirst(x,"*",info.individualinfo)
      While d=0
        a$=PeekS(@info\szFileName)
        ;Debug a$
        If a$="null"
          Debug "TONULL"
        EndIf
        
        If Right(a$,1)<>"\" And Right(a$,1)<>"/"
          AddElement(tojar())
          ;Debug "add "+a$
          tojar()\file=a$
          tojar()\crc=info\dwCRC
          tojar()\size=info\dwOriginalSize
          tojar()\date=ParseDosDateTime(info\wDate,info\wtime)
        EndIf
        ;EndIf
        d=SevenZipFindNext(x,info)
      Wend
      ret=SevenZipCloseArchive(x)
    EndIf
    
    
     
    Debug "search changed"
    out=CreateFile(#PB_Any,patchfile)
    
    
    If out
      ForEach tojar()
        ;Debug "add "+tojar()\file
        
        WriteByte(out,Len(tojar()\file))
        WriteString(out,tojar()\file)
        WriteLong(out,tojar()\crc)
        WriteLong(out,tojar()\date)
        WriteLong(out,tojar()\size)
        
        If fromjar(tojar()\file)\crc=tojar()\crc And fromjar(tojar()\file)\size=tojar()\size
          ;Debug tojar()\file+" identisch"
          WriteByte(out,1); datei ist identisch
        ElseIf tojar()\size=0
          ;Debug  tojar()\file+" Zerofile"
          WriteByte(out,1);Null-datei
        ElseIf fromjar(tojar()\file)\size=0
          ;Debug tojar()\file+" neu"
          WriteByte(out,2); Datei ist neu
          *mem=AllocateMemory(tojar()\size)
          in=ReadFile(#PB_Any,patchdir+"tofiles\"+tojar()\file)
          If in
            ReadData(in,*mem,tojar()\size)
            CloseFile(in)
          Else
            Debug "can't open "+tojar()\file
            End
          EndIf
          WriteData(out,*mem,tojar()\size)
        Else
          ;Debug tojar()\file+" unterschiedlich"
          WriteByte(out,3);Unterschiedlich
          l1=tojar()\size
          l2=fromjar(tojar()\file)\size
          ;Debug Str(l1)+" "+Str(l2)
          *mem1=AllocateMemory(l1+4)
          *mem2=AllocateMemory(l2+4)
          *stop1=*mem1+l1-1
          *stop2=*mem2+l2-1
          
          in=ReadFile(#PB_Any,patchdir+"tofiles\"+tojar()\file)
          If in
            ReadData(in,*mem1,l1)
            CloseFile(in)
          Else
            Debug "can't open to\"+tojar()\file
            End
          EndIf
          in=ReadFile(#PB_Any,patchdir+"fromfiles\"+tojar()\file)
          If in
            ReadData(in,*mem2,l2)
            CloseFile(in)
          Else
            Debug "can't open from\"+tojar()\file
          EndIf
          
          ;so datei untersuchen
          
          startunchanged=0
          For pos1=0 To l1-10
            ok=#False
            count=10
            For pos2=pos1-120 To pos1+120
              If pos2<0
                pos2=0
              ElseIf pos2>L2-5
                Break
              EndIf
              ;Debug pos2
              
              *b1.byte=*mem1+pos1
              *b2.byte=*mem2+pos2
              c=0
              While *b1\b=*b2\b And *b1<*stop1 And *b2<*stop2 And c<65535
                *b1+1:*b2+1:c+1
              Wend
              If c>count
                ok=#True
                count=c
                delta=pos2-pos1
              EndIf
            Next
            If ok
              ;Debug "neu:"+Str(startunchanged)+" To "+Str(pos1-1)+" ="+Str(pos1-1-startunchanged)
              d=pos1-1-startunchanged
              If d>=0
                If d>=0 And d<=99
                  ;Debug d+101
                  WriteByte(out,d+101);*write\b=d+101:*write+1
                  WriteData(out,*mem1+startunchanged,d+1);CopyMemory(*mem1+startunchanged,*write,d+1):*write+d+1
                ElseIf d<256
                  ;Debug 1
                  WriteByte(out,1);*write\b=1:*write+1
                  WriteByte(out,d);*write\b=d:*write+1
                  WriteData(out,*mem1+startunchanged,d+1);CopyMemory(*mem1+startunchanged,*write,d+1):*write+d+1
                ElseIf d<65535
                  ;Debug 2
                  WriteByte(out,2);*write\b=2:*write+1
                  WriteWord(out,d);PokeW(*write,d):*write+2
                  WriteData(out,*mem1+startunchanged,d+1);CopyMemory(*mem1+startunchanged,*write,d+1):*write+d+1
                Else
                  ;Debug 201
                  WriteByte(out,201);*write\b=2:*write+1
                  WriteLong(out,d);PokeW(*write,d):*write+2
                  WriteData(out,*mem1+startunchanged,d+1);CopyMemory(*mem1+startunchanged,*write,d+1):*write+d+1
                EndIf
              EndIf    
              
              ;Debug "copy:"+Str(pos1)+" to "+Str(pos1+count-1)+"  delta:"+Str(delta)+" "+Str(count)
              If count>=5 And count<=100
                ;Debug count
                WriteByte(out,count);*write\b=count:*write+1
                WriteByte(out,delta);*write\b=delta:*write+1
              ElseIf count<256+1+100
                ;Debug 3
                WriteByte(out,3);*write\b=3:*write+1
                WriteByte(out,delta);*write\b=delta:*write+1
                WriteByte(out,count-1-100);*write\b=count-1-100:*write+1
              Else
                ;Debug 4
                WriteByte(out,4);*write\b=4:*write+1
                WriteByte(out,delta);*write\b=delta:*write+1
                WriteWord(out,count-1-100);PokeW(*write,count-1-100):*write+2
              EndIf
              pos1+count
              startunchanged=pos1
            EndIf
          Next
          d=l1-1-startunchanged
          If d>=0
            If d>=0 And d<=99
              ;Debug d+101
              WriteByte(out,d+101);*write\b=d+101:*write+1
              WriteData(out,*mem1+startunchanged,d+1);CopyMemory(*mem1+startunchanged,*write,d+1):*write+d+1
            ElseIf d<256
              ;Debug 1
              WriteByte(out,1);*write\b=1:*write+1
              WriteByte(out,d);*write\b=d:*write+1
              WriteData(out,*mem1+startunchanged,d+1);CopyMemory(*mem1+startunchanged,*write,d+1):*write+d+1
            ElseIf d<65535
              ;Debug 2
              WriteByte(out,2);*write\b=2:*write+1
              WriteWord(out,d);PokeW(*write,d):*write+2
              WriteData(out,*mem1+startunchanged,d+1);CopyMemory(*mem1+startunchanged,*write,d+1):*write+d+1
            Else
              ;Debug 201
              WriteByte(out,201);*write\b=2:*write+1
              WriteLong(out,d);PokeW(*write,d):*write+2
              WriteData(out,*mem1+startunchanged,d+1);CopyMemory(*mem1+startunchanged,*write,d+1):*write+d+1
            EndIf
          EndIf  
          
          WriteByte(out,0);*write\b=0:*write+1
          
          
          FreeMemory(*mem1)
          FreeMemory(*mem2)
          ;-----
          
          
        EndIf
      Next
      CloseFile(out)
      
      
    EndIf
  EndIf
  ;End ;- nur erste Patchfile
Wend


End

; x=SevenZipOpenArchive(win7zid,"Minecraft Version\1.2.5_minecraft.jar")
; If x
;   Debug "geffnet"
;   d=SevenZipFindFirst(x,"*",info.individualinfo)
;   While d=0
;     Debug PeekS(@info\szFileName)+" "+Hex(info\dwCRC)+" "+Str(info\dwOriginalSize)
;     If CRC32FileFingerprint("Minecraft Version\1.2.5_minecraft\"+PeekS(@info\szFileName))<>info\dwCRC
;       Debug "Diffrent CRC! "
;     EndIf
;     d=SevenZipFindNext(x,info)
;   Wend
;   ret=SevenZipCloseArchive(x)
;   Debug ret
; EndIf

; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 125
; FirstLine = 105
; Folding = -
; EnableXP